=== modified file 'charmworld.egg-info/SOURCES.txt'
--- charmworld.egg-info/SOURCES.txt	2011-10-27 20:05:05 +0000
+++ charmworld.egg-info/SOURCES.txt	2011-12-17 03:16:48 +0000
@@ -8,10 +8,10 @@
 setup.py
 charmworld/__init__.py
 charmworld/db.py
+charmworld/debugpanel.py
 charmworld/globals.py
-charmworld/install.txt
 charmworld/models.py
-charmworld/queues.txt
+charmworld/reports.py
 charmworld/resources.py
 charmworld/tests.py
 charmworld/todo.txt
@@ -40,6 +40,7 @@
 charmworld/static/pylons.css
 charmworld/static/pyramid-small.png
 charmworld/static/pyramid.png
+charmworld/static/report.js
 charmworld/static/transparent.gif
 charmworld/static/prettify/lang-apollo.js
 charmworld/static/prettify/lang-clj.js
@@ -61,57 +62,17 @@
 charmworld/static/prettify/lang-yaml.js
 charmworld/static/prettify/prettify.css
 charmworld/static/prettify/prettify.js
-charmworld/static/psrc/CHANGES.html
-charmworld/static/psrc/README-zh-Hans.html
-charmworld/static/psrc/README.html
-charmworld/static/psrc/closure-compiler/console-externs.js
-charmworld/static/psrc/js-modules/combinePrefixPatterns.js
-charmworld/static/psrc/js-modules/externs.js
-charmworld/static/psrc/js-modules/extractSourceSpans.js
-charmworld/static/psrc/js-modules/extractSourceSpans_test.html
-charmworld/static/psrc/js-modules/numberLines.js
-charmworld/static/psrc/js-modules/numberLines_test.html
-charmworld/static/psrc/js-modules/prettify.js
-charmworld/static/psrc/js-modules/recombineTagsAndDecorations.js
-charmworld/static/psrc/js-modules/recombineTagsAndDecorations_test.html
-charmworld/static/psrc/src/lang-apollo.js
-charmworld/static/psrc/src/lang-clj.js
-charmworld/static/psrc/src/lang-css.js
-charmworld/static/psrc/src/lang-go.js
-charmworld/static/psrc/src/lang-hs.js
-charmworld/static/psrc/src/lang-lisp.js
-charmworld/static/psrc/src/lang-lua.js
-charmworld/static/psrc/src/lang-ml.js
-charmworld/static/psrc/src/lang-n.js
-charmworld/static/psrc/src/lang-proto.js
-charmworld/static/psrc/src/lang-scala.js
-charmworld/static/psrc/src/lang-sql.js
-charmworld/static/psrc/src/lang-tex.js
-charmworld/static/psrc/src/lang-vb.js
-charmworld/static/psrc/src/lang-vhdl.js
-charmworld/static/psrc/src/lang-wiki.js
-charmworld/static/psrc/src/lang-xq.js
-charmworld/static/psrc/src/lang-yaml.js
-charmworld/static/psrc/src/prettify.css
-charmworld/static/psrc/src/prettify.js
-charmworld/static/psrc/styles/demo.html
-charmworld/static/psrc/styles/desert.css
-charmworld/static/psrc/styles/index.html
-charmworld/static/psrc/styles/sunburst.css
-charmworld/static/psrc/tests/ie-newline-copy-paste.html
-charmworld/static/psrc/tests/large_input_test.html
-charmworld/static/psrc/tests/prettify_test.html
-charmworld/static/psrc/tests/prettify_test_2.html
-charmworld/static/psrc/tests/test_base.js
-charmworld/static/psrc/tests/test_styles.css
 charmworld/templates/charm-collection.pt
 charmworld/templates/charm.pt
+charmworld/templates/charmers.pt
 charmworld/templates/config.pt
 charmworld/templates/hook.pt
 charmworld/templates/index.pt
+charmworld/templates/interface-collection-redux.pt
 charmworld/templates/interface-collection.pt
 charmworld/templates/interface.pt
 charmworld/templates/main.pt
 charmworld/templates/mytemplate.pt
 charmworld/templates/recent.pt
+charmworld/templates/reports.pt
 charmworld/templates/search.pt
\ No newline at end of file

=== modified file 'charmworld/__init__.py'
--- charmworld/__init__.py	2011-12-16 21:48:45 +0000
+++ charmworld/__init__.py	2011-12-17 03:16:48 +0000
@@ -28,16 +28,21 @@
 
     config.add_route("charmers", "/charmers")
 
+    # Distro/Curated Charms
     config.add_route("charm-collection", "/charms")
     config.add_route("series-collection", "/charms/{series}")
     config.add_route("charm", "/charms/{series}/{charm}")
+    config.add_route("charm-changes", "/charms/{series}/{charm}/changes")
     config.add_route("hook", "/charms/{series}/{charm}/hooks/{hook}")
     config.add_route("config", "/charms/{series}/{charm}/config")
 
+    # Personal Charms
     config.add_route("personal-collection", "/~{owner}")
     config.add_route("personal-series", "/~{owner}/{series}")
     config.add_route("personal-charm", "/~{owner}/{series}/{charm}")
     config.add_route(
+        "personal-charm-changes", "/~{owner}/{series}/{charm}/changes")
+    config.add_route(
         "personal-hook", "/~{owner}/{series}/{charm}/hooks/{hook}")
     config.add_route(
         "personal-config", "/~{owner}/{series}/{charm}/config")
@@ -47,7 +52,7 @@
     config.add_route("interface-collection-map", "/interface-charm-map")
 
     config.add_route("recently-changed", "/recently-changed")
-    config.add_route("recently-changed-feed", "/changes-feed")
+    config.add_route("recently-changed-feed", "/feed/charm-changes")
     config.add_route("search", "/search")
     config.add_route("home", "/")
     config.scan("charmworld")

=== removed file 'charmworld/db.py'
--- charmworld/db.py	2011-10-09 06:25:04 +0000
+++ charmworld/db.py	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-import pymongo
-from gridfs import GridFS
-
-from pyramid.events import subscriber
-from pyramid.interfaces import INewRequest
-
-connection = pymongo.Connection()
-
-
-#@subscriber(INewRequest)
-def add_mongodb(event):
-    event.request.db = db = connection.juju
-    event.request.fs = GridFS(db)

=== modified file 'charmworld/globals.py'
--- charmworld/globals.py	2011-10-28 14:33:30 +0000
+++ charmworld/globals.py	2011-12-17 03:16:48 +0000
@@ -1,9 +1,44 @@
 
 
+def breadcrumbs(request):
+    crumbs = []
+    parts = filter(None, request.path_info.split("/"))
+    if not len(parts) > 1:
+        return []
+    parts.insert(0, '')
+    for i in range(1, len(parts)):
+        crumbs.append({"url": "/".join(parts[: i + 1]),
+                       "name": parts[i].replace(
+                           "-", " ").replace("~", "").capitalize()})
+    crumbs.insert(0, {'url': '/', 'name': 'Home'})
+    return crumbs
+
+
+def sections(request):
+    sections = [
+        {"url": "/", "name": "Home", 'active': False},
+        {"url": "/charms", "name": "Charms", 'active': False},
+        {"url": "/interfaces", "name": "Interfaces", 'active': False},
+        {"url": "/recently-changed", "name": "Changes", 'active': False},
+        ]
+    section = "/%s" % request.path_info[1:].split("/", 1)[0]
+    # fix up oddballs
+    if section.startswith("/~"):
+        section = "/charms"
+    elif section == "/interface-charm-map":
+        section = "/interfaces"
+    for s in sections:
+        if s['url'] == section:
+            s['active'] = True
+    return sections
+
+
 def default_globals_factory(system):
     context, request = system['context'], system['request']
 
     return {
         'project': 'Charm Browser',
         'onload': '',
+        'breadcrumbs': breadcrumbs(request),
+        'sections': sections(request)
         }

=== modified file 'charmworld/jobs/index.py'
--- charmworld/jobs/index.py	2011-10-10 21:59:58 +0000
+++ charmworld/jobs/index.py	2011-12-17 03:16:48 +0000
@@ -137,7 +137,8 @@
     #root_dir = os.path.abspath(
     #    os.path.expanduser("~/projects/charmworld/repo"))
     #index_repo(db, indexer, root_dir)
-
+    indexer.close()
     log.info("Indexed Repo")
+
 if __name__ == '__main__':
     main()

=== modified file 'charmworld/templates/charm.pt'
--- charmworld/templates/charm.pt	2011-10-12 03:24:11 +0000
+++ charmworld/templates/charm.pt	2011-12-17 03:16:48 +0000
@@ -3,6 +3,9 @@
 
     <metal:block fill-slot="js_include">
       <script type="text/javascript"
+	      src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js">
+	</script>
+      <script type="text/javascript"
 	      src="${request.static_url('charmworld:static/prettify/prettify.js')}">
       </script>
     </metal:block>
@@ -10,6 +13,8 @@
     <metal:block fill-slot="css_include">
       <link type="text/css" rel="stylesheet"
             href="${request.static_url('charmworld:static/prettify/prettify.css')}" />
+      <link rel="alternate" type="application/atom+xml"
+	    href="${name}/changes" title="Atom ${name} changes feed"/>
     </metal:block>
 
     <metal:block fill-slot="content">
@@ -42,14 +47,16 @@
 	  </div>
 	  <div class="field">
 	    <b>Links</b><br/>
-	    <a href="https://code.launchpad.net/${charm['branch_spec']}">Repository</a>
+	    <a href="https://bazaar.launchpad.net/${charm['branch_spec']}/files">Repository</a>
 	    &nbsp;
 	    <a href="https://bugs.launchpad.net/charm/${charm['series']}/+source/${charm['name']}">Bugs </a>
+	    <br>
+	    lp:${charm['branch_spec']}
 	  </div>
 
         </div>
 
-	<div class="span3">
+	<div class="span4">
 	  <h5>Hooks</h5>
 	    <ul class="unstyled">
 	      <li tal:repeat="hook charm['hooks']"><a href="${name}/hooks/${hook}">${hook}</a></li>
@@ -91,15 +98,21 @@
       <div class="row">
 	
 	<div class="span10">
+	  <metal:block tal:condition="readme">
+	    <h5>Readme</h5>
+	    <pre tal:content="readme"></pre>
+	  </metal:block>
+
 	  <h5>Changes</h5>
-            <table class="zebra-striped">
+            <table id="charm-changes" class="zebra-striped">
                 <tbody>
-                    <tr tal:repeat="change charm['changes']">
+                  <tr tal:repeat="change charm['changes']">
 		      <td tal:content="structure: format_change(change, charm)"></td>
 		    </tr>
                 </tbody>		
             </table>
 	</div>
+
 	<div class="span6" tal:condition="others">
 	    <h5>In other archives</h5>
 	    <span tal:repeat="other others">

=== modified file 'charmworld/templates/interface-collection-redux.pt'
--- charmworld/templates/interface-collection-redux.pt	2011-11-17 11:01:14 +0000
+++ charmworld/templates/interface-collection-redux.pt	2011-12-17 03:16:48 +0000
@@ -4,13 +4,13 @@
 <metal:block metal:fill-slot="content">
   <div class="well">
     <em class="pull-right"> Interfaces: ${len(interfaces)}</em>
-    <span class="pull-right"><a href="/interface-charm-map">Interface charm map</a>&nbsp;&nbsp;</span>
+    <span class="pull-right"><b><a href="/interface-charm-map">Interface charm map</a></b>&nbsp;&nbsp;</span>
     <table class="zebra-stripped">
       <thead>
         <tr>
           <th>Interface</th>
-          <th>R</th>
-          <th>P</th>
+          <th>Provides</th>
+          <th>Requires</th>
         </tr>
       </thead>
       <tr tal:repeat="iface interfaces">

=== modified file 'charmworld/templates/interface-collection.pt'
--- charmworld/templates/interface-collection.pt	2011-11-17 11:01:14 +0000
+++ charmworld/templates/interface-collection.pt	2011-12-17 03:16:48 +0000
@@ -6,7 +6,7 @@
 
   <div class="well">
     <em class="pull-right"> Interfaces: ${len(interfaces)}</em>
-    <span class="pull-right"><a href="/interfaces">Interface listing</a>&nbsp;&nbsp;</span>
+    <span class="pull-right"><b><a href="/interfaces">Interface listing</a></b>&nbsp;&nbsp;</span>
 
     <table class="zebra-stripped">
     <thead>

=== modified file 'charmworld/templates/main.pt'
--- charmworld/templates/main.pt	2011-11-17 01:33:13 +0000
+++ charmworld/templates/main.pt	2011-12-17 03:16:48 +0000
@@ -50,20 +50,30 @@
         <div class="container">
           <span class="brand" href="#">${project}</span>
           <ul class="nav">
-            <li class="active"><a href="/">Home</a></li>
-            <li><a href="/charms">Charms</a></li>
-            <li><a href="/interfaces">Interfaces</a></li>
-            <li><a href="/recently-changed">Changes</a></li>
+            <tal:block tal:repeat="section sections">
+              <li tal:condition="section['active']" class="active">
+                <a href="${section['url']}">${section['name']}</a></li>
+              <li tal:condition="not section['active']">
+                <a href="${section['url']}">${section['name']}</a></li>
+            </tal:block>
           </ul>
-	  <form class="pull-right" style="margin-top: 10px" method="get" action="/search">
-	    <input type="text" style="height: 20px" name="search_text" placeholder="Search"/>
-	  </form>
+          <form class="pull-right" style="margin-top: 10px" method="get" action="/search">
+            <input type="text" style="height: 20px" name="search_text" placeholder="Search"/>
+          </form>
         </div>
       </div>
     </div>
 
     <div class="container">
 
+      <metal:block tal:condition="breadcrumbs">
+        <ul class="breadcrumb">
+          <li tal:repeat="crumb breadcrumbs[:-1]">
+              <a href="${crumb['url']}">${crumb['name']}</a><span class="divider">/</span></li>
+          <li class="active" tal:content="breadcrumbs[-1]['name']"></li>
+        </ul>
+      </metal:block>
+
       <tal:block metal:define-slot="content" />
 
       <!--

=== modified file 'charmworld/templates/recent.pt'
--- charmworld/templates/recent.pt	2011-10-12 03:24:11 +0000
+++ charmworld/templates/recent.pt	2011-12-17 03:16:48 +0000
@@ -1,6 +1,11 @@
 <html tal:define="main load: main.pt" metal:use-macro="main.macros['page']">
   <body>
 
+<metal:block metal:fill-slot="css_include">
+  <link rel="alternate" type="application/atom+xml"
+	href="/feed/charm-changes" title="Atom changes feed"/>
+</metal:block>
+
 <metal:block metal:fill-slot="content">
 
   <h3> Recently changed </h3>

=== modified file 'charmworld/todo.txt'
--- charmworld/todo.txt	2011-10-12 05:08:46 +0000
+++ charmworld/todo.txt	2011-12-17 03:16:48 +0000
@@ -1,5 +1,20 @@
-
-
+TODO
+----
+
+Remove old charms.
+Show charm lint information.
+Check hooks are replaced on scan.
+
+DONE
+----
+
+X- Breadcrumb navigation.
+X- Link to repo browser view instead of landing.
+X- Display Bzr Repo for bzr co
+X- Highlight correct tab.
+X- Display Readme on charm.
+X- RSS feed for charm.
+X- RSS feed for all changes.
 X- browser hooks ttw
 X- show config
 X- show relations

=== modified file 'charmworld/views.py'
--- charmworld/views.py	2011-12-16 21:48:45 +0000
+++ charmworld/views.py	2011-12-17 03:16:48 +0000
@@ -1,4 +1,5 @@
 from datetime import datetime, timedelta
+import fnmatch
 import os
 
 from webob import Response
@@ -16,7 +17,7 @@
 PROJECT_NAME = "Charm Browser"
 
 # 15m which is the cron ingest cycle (also clears cache)
-HTTP_CACHE = 950
+HTTP_CACHE = None  # 950
 
 
 def _found(res):
@@ -151,7 +152,54 @@
     return _charm_view(charm)
 
 
+@view_config(route_name="personal-charm-changes", http_cache=HTTP_CACHE)
+def personal_charm_changes(request):
+    charm = _found(db.charms.find_one(
+        {"name": request.matchdict['charm'],
+         "owner": request.matchdict['owner'],
+         "series": request.matchdict['series']}))
+    feed = _charm_changes_feed(charm, request)
+    return Response(feed.writeString("utf8"),
+                    content_type=u"application/atom+xml")
+
+
+@view_config(route_name="charm-changes", http_cache=HTTP_CACHE)
+def charm_changes(request):
+    charm = _found(db.charms.find_one(
+        {"name": request.matchdict['charm'],
+         "owner": "charmers",
+         "series": request.matchdict['series']}))
+    feed = _charm_changes_feed(charm, request)
+    return Response(feed.writeString("utf8"),
+                    content_type=u"application/atom+xml")
+
+
+def _charm_changes_feed(charm, request):
+    feed = feedgenerator.Atom1Feed(
+        title=u"Charm browser changes",
+        description="Recently changed charms",
+        link=request.url,
+        language=u"en"
+        )
+
+    for change in charm['changes']:
+        committer = change['committer']
+        committer = committer.split("<", 1)[0].strip()
+        diff_link = u"https://bazaar.launchpad.net/%s/revision/%s" % (
+            charm["branch_spec"], change["revno"])
+
+        feed.add_item(
+            title=charm['name'],
+            link=diff_link,
+            description=change['message'].strip().replace("\n", "<br/>"),
+            author_name=committer,
+            pub_date=feedgenerator.rfc3339_date(
+                datetime.fromtimestamp(change['created'])))
+    return feed
+
+
 def format_change(change, charm=None):
+    """Format a bzr commit."""
     parts = []
     date = datetime.fromtimestamp(change["created"])
     parts.append(date.strftime("%Y/%m/%d"))
@@ -196,8 +244,24 @@
         {"name": charm["name"], "series": charm["series"],
          "branch_spec": {"$ne": charm["branch_spec"]}}))
 
+    readme = _charm_readme(charm)
+
     return {"project": PROJECT_NAME, "charm": charm, "name": charm["name"],
-            "others": others, 'format_change': format_change}
+            "others": others, 'format_change': format_change, "readme": readme}
+
+
+def _charm_readme(charm):
+    # Find a readme
+    dirents = os.listdir(charm['branch_dir'])
+    dirents = dict([(k.lower(), v) for k, v in zip(dirents, dirents)])
+    matches = fnmatch.filter(dirents.keys(), "readme*")
+    if not matches:
+        return None
+    matches.sort(lambda x, y: cmp(len(x), len(y)))
+    readme_path = os.path.join(charm['branch_dir'], dirents[matches[0]])
+
+    with open(readme_path) as fh:
+        return fh.read()
 
 
 @view_config(
@@ -333,12 +397,6 @@
                                     sort=[("name", pymongo.ASCENDING)]))}
 
 
-@view_config(
-    route_name="recently-changed", renderer="charmworld:templates/recent.pt")
-def recently_changed(request):
-    return _recently_changed()
-
-
 def _recently_changed():
     charms = db.charms.find({}, {"last_change": 1,
                                  "label": 1,
@@ -351,6 +409,12 @@
     return {"charms": charms, 'format_change': format_change}
 
 
+@view_config(
+    route_name="recently-changed", renderer="charmworld:templates/recent.pt")
+def recently_changed(request):
+    return _recently_changed()
+
+
 @view_config(route_name="recently-changed-feed")
 def recently_changed_feed(request):
     feed = feedgenerator.Atom1Feed(

=== modified file 'requirements.txt'
--- requirements.txt	2011-10-10 05:33:34 +0000
+++ requirements.txt	2011-12-17 03:16:48 +0000
@@ -12,7 +12,6 @@
 pymongo==2.0.1
 pyramid==1.2.1
 pyramid-debugtoolbar==0.9.4
-pyramid-jinja2==1.2
 redis==2.4.9
 repoze.lru==0.4
 simplejson==2.2.1
@@ -24,3 +23,4 @@
 zope.deprecation==3.5.0
 zope.event==3.5.1
 zope.interface==3.8.0
+WebHelpers==1.3

